/*
 *	main.c
 *
 *	ANAbVǂ
 *
 *	* Wed May  3 03:37:00 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	int i;

	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* `B */
	for(i = 0; i < EFFECT_NUM; i++) {
		effect_surface[i].w = DISP_X;
		effect_surface[i].h = DISP_Y;
		effect_surface[i].vbuff = effect_vbuff[i];
		render_init_2d(&effect_render[i], &effect_surface[i], 0, 0, 0, 0);
	}

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#include "texture.h"
#undef TEXTURE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#include "texture.h"
#undef TEXTURE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
			{ /* vbuff(c)_def_vbuff()ϊ */
				unsigned char *dst, *src;
				dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
				src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
				for(x = DISP_X - 1; x >= 0; x--) {
					for(y = 0; y < DISP_Y; y++) {
						*dst = *src;
						dst += 1;      /* ʂEɑ܂ */
						src += DISP_X; /* cʂɑ܂ */
					}
					                            /* ʂ͊Ɏ̍sֈړĂ܂ */
					src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
				}
			}
#endif /*V_SCREEN*/
			pceLCDTrans();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_SELECT) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	return 0;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&game, 0, sizeof(GAME));

	/* TODO: */
}

/****************************************************************************
 *	stage_init
 ****************************************************************************/

void
stage_init()
{
	game.chain = 0;
	game.chain_num = 0;
	game.chain_row = 0;
	game.chain_cnt = 0;

	game.erase_cnt = 0;
	game.rring_cnt = 0;
	memset(game.debris, 0, sizeof game.debris);
	memset(game.ring, 0, sizeof game.ring);
	memset(game.smoke, 0, sizeof game.smoke);

	//game.block_col  ̂܂
	//game.block_row  ̂܂
	//game.block_pos  ̂܂
	//game.block_land ̂܂
	//game.block      ̂܂

	game.goal = 0;
	game.goal_row = -25; /* TODO: */

	game.down_cnt = 0;
	memset(game.field, 0, sizeof game.field);

	/* ŝ܂ŃubNzu܂B */
	memset(game.field, 0, sizeof game.field);
	while(field_test() < OUTER_ROWS) {
		field_action(1);
	}
}

/****************************************************************************
 *	block_init
 ****************************************************************************/

typedef struct _BFORM {
	unsigned char form[2][BLOCK_COLS];
	short rate;
} BFORM;

static const BFORM bform_tbl[] = {
	{{{1,1,1},{1,0,0}},10},
	{{{1,1,1},{0,1,0}},10},
	{{{1,1,1},{1,1,0}},10},
	{{{1,1,1},{0,0,1}},10},
	{{{1,1,1},{1,0,1}},10},
	{{{1,1,1},{0,1,1}},10},
	{{{1,1,1},{1,1,1}},10},
	/*-------------------*/
	{{{1,0,0},{1,1,1}},10},
	{{{0,1,0},{1,1,1}},10},
	{{{1,1,0},{1,1,1}},10},
	{{{0,0,1},{1,1,1}},10},
	{{{1,0,1},{1,1,1}},10},
	{{{0,1,1},{1,1,1}},10},
	/*-------------------*/
	{{{1,1,1},{1,1,1}},20},
	{{{1,1,1},{0,0,0}},20},
	{{{0,1,0},{0,0,0}}, 5},
};
#define BFORM_CNT ARRAY_SIZE(bform_tbl)

void
block_init()
{
	int i;
	int n;
	int col;
	int row;

	game.block_col = (FIELD_COLS - BLOCK_COLS) / 2;
	game.block_row = OUTER_ROWS;
	game.block_pos = fild(2);
	game.block_land = 0;

	n = 0;
	for(i = 0; i < BFORM_CNT; i++) {
		n += bform_tbl[i].rate;
	}
	n = RND16_RANGE(seed, 0, n);
	for(i = 0; i < BFORM_CNT; i++) {
		n -= bform_tbl[i].rate;
		if(n < 0) {
			break;
		}
	}
	if(i == BFORM_CNT) {
		DIE(); /* L蓾Ȃ */
	}

	memset(game.block, 0, sizeof game.block);
	for(row = 0; row < 2; row++) {
		for(col = 0; col < BLOCK_COLS; col++) {
			if(bform_tbl[i].form[row][col]) {
				game.block[BLOCK_ROWS - 2 + row][col] = CELL_SIZE;
			}
		}
	}
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

void
game_main()
{
	int i;

	/* Q[B */
	game_init();
	block_init();

	for(;;) {
		/* Xe[WB */
		stage_init();

		for(;;) {
			/* ʏ푀̃[v */
			for(i = 0; /** no job **/; i++) {
				schedule();
				/* tB[h̃ubN~܂B
				 * - ʏ푀̃[vJnAxč~Jn܂B
				 */
				if(!field_action(i >= SEC(0.25/**/))) {
					goto L_GAMEOVER;
				}
				/* ubN̈ړALсA㏸s܂B
				 * - ʏ푀̃[vJnAxď㏸Jn܂B
				 *   tB[h̃ubN[UsɒB܂ł́A㏸Jn܂B
				 */
				if(block_action(1, i >= SEC(0.5/**/) && field_test() >= BFILL_ROWS)) {
					break; /* 슮 */
				}
				field_disp(1);
			}
			field_disp(0/*ubN*/);

			/* ubN̎̉`ŊJn܂ŁA҂܂B */
			for(i = 0; i < SEC(0.25/**/); i++) {
				schedule();
				field_disp(0/*ubN*/);
			}
			block_init(); /* ŊJn̑OɁȂubNpӂA\Ƃ */

			/* A[v */
			while(erase_init()) {
				if(game.goal) {
					goto L_CLEAR;
				}

				/* ŁẼ[v */
				for(;;) {
					schedule();
					/* ŏis܂B */
					if(!erase_action()) {
						break; /* Ŋ */
					}
					/* ŒAubN̈ړALт\łB㏸͕słB */
					block_action(1, 0);
					field_disp(1);
				}
				field_disp(1);
			}
		}
L_CLEAR:
		game_clear();
	}
L_GAMEOVER:
	game_over();
}

/****************************************************************************
 *	game_clear
 ****************************************************************************/

void
game_clear()
{
	int col;
	int row;
	CELL* cell;
	int i;
	fixed d;

	/***** Xe[WNAGtFNg(O) *****/

	game.rring_cnt = RRING_TIME;
	do {
		schedule();
		block_action(0, 0);
		field_disp(1);
	} while(game.rring_cnt);

	/***** Xe[WNAGtFNg(㔼) *****/

	/* jЃGtFNg𐶐܂B */
	debris_gen(game.goal_row, game.goal_row, 16/**/);

	/* OGtFNg𐶐܂B */
	d = FRND_RANGE(seed, 0, PI2);
	for(i = 0, d = FRND_RANGE(seed, 0, PI);
	    i < 3;
	    i++  , d = fadd(d, fidiv(PI, 3))) {
		ring_gen(game.goal_row, game.goal_row, d);
	}

	/* SubNłAGtFNg𐶐܂B */
	for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			cell->stat = CELL_STAT_ERASE; /* vBIɏǂ? */
			smoke_gen(col, row, FRND_RANGE(seed, 0, SMOKE_DIST_MAX));
		}
	}

	/* TODO: łBGtFNgS܂łƑ҂ƁB */
	for(i = 0; i < SEC(5); i++) {
		schedule();
		block_action(0, 0);
		erase_action(); /* vBIɏǂ? */
		field_disp(1);
	}
}

/****************************************************************************
 *	game_over
 ****************************************************************************/

void
game_over()
{
	int col;
	int row;
	CELL* cell;
	int i;

	/* Q[I[o[̏uԂ́AGtFNg𐶐܂B */
	for(row = DLINE_ROWS; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(!cell->type) {
				continue;
			}
			for(i = 0; i < 8/**/; i++) {
				smoke_gen(col, row, FRND_RANGE(seed, 0, SMOKE_DIST_MAX));
			}
		}
	}

	/* Q[I[o[\B */
	for(i = 0; i < SEC(10/**/); i++) {
		schedule();
/*{{TODO: ƌhBƏȉŁApx肩BƂłȂƂB*/
		if(i & 1) { /* ܂΂ȉ𐶐 */
			col = RND16_RANGE(seed,          0, FIELD_COLS);
			row = RND16_RANGE(seed, DLINE_ROWS, FIELD_ROWS);
			cell = &game.field[row][col];
			if(cell->type) {
				smoke_gen(col, row, 0);
			}
		}
/*}}TODO: ƌhBƏȉŁApx肩BƂłȂƂB*/
		field_disp(0/*ubN*/);
		if(i >= SEC(2/**/)) {
			render_string_framed(&render,
				(DISP_X - 5 * 9) / 2 - 1, (DISP_Y - 10) / 2 - 1,
				"GAME OVER",
				0x80, 0x00f);
			if(joy & (TRG_A | TRG_B | TRG_START)) {
				break;
			}
		}
	}
}

/****************************************************************************
 *	field_gen
 ****************************************************************************/

void
field_gen()
{
	/*  */

	int i;
	int n;
	int col;
	int col_tbl[FIELD_COLS];
	CELL* cell;

	if(game.goal_row > 0) {
		return; /* S[š͉܂ */
	}

	for(col = 0; col < FIELD_COLS; col++) {
		col_tbl[col] = col;
	}
	shuffle(col_tbl, FIELD_COLS, sizeof col_tbl[0], &seed);

	n = RND16_RANGE(seed, FIELD_COLS / 2, FIELD_COLS);
	for(i = 0; i < n; i++) {
		col = col_tbl[i];
		cell = &game.field[0][col];
		cell->type = CELL_TYPE_STAGE;
	}
}

/****************************************************************************
 *	field_test
 ****************************************************************************/

/* tB[hŁA΂񉺂ɗLubN܂ł̍sԂ܂B
 * - sԍł͂ȂƂɒӂĂ!!
 *   ʓ̍ŏs(sԍ=OUTER_ROWS)ɃubN΁AOUTER_ROWS+1Ԃ܂B
 *   ubN[Uŉs(sԍ=BFILL_ROWS-1)܂ŃubN΁ABFILL_ROWSԂ܂B
 *   fbhĈ(sԍ=DLINE_ROWS-1)܂ŃubN΁ADLINE_ROWSԂ܂B
 *   fbhCsăubN΁ADLINE_ROWS+1Ԃ܂B
 */
int
field_test()
{
	int col;
	int row;
	CELL* cell;

	for(row = FIELD_ROWS - 1; row >= 0; row--) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &game.field[row][col];
			if(cell->type) {
				goto L_EXIT;
			}
		}
	}
L_EXIT:
	return row + 1;
}

/****************************************************************************
 *	field_action
 ****************************************************************************/

int
field_action(int f_down/*0=~s,1=~*/)
{
	int rows;
	int interval;

	/* ~ */
	if(f_down) {
		/* tB[h~JE^i߂܂B */
		game.down_cnt++;

		/* ubNsɂāAC^[oI܂B */
		rows = field_test();
		if(rows < BFILL_ROWS) {
			interval = BFILL_INTERVAL;
		} else if(rows < BWARN_ROWS) {
			interval = BDOWN_INTERVAL;
		} else {
			interval = BWARN_INTERVAL;
		}

		/* \Ȃ΁AtB[h~܂B
		 * - {́AtB[h~ɑubN1s܂B
		 *   tB[h̃ubNƁAubNdȂ邱Ƃ邽߂łB
		 * - ΂āA{vOł́AubN܂B
		 *   ̑ɁA炩߁AubNdȂȂƂmF܂B
		 *   AtB[h~ƑubNɏdȂȂ΁A~܂B
		 * - Ė{ƈႤƂŔAhłB
		 *   ܂A쐫ǂƎv܂B
		 */
		if((game.down_cnt >= interval) &&
		   (rows < FIELD_ROWS)) {
			/*{{tB[h~*/
			memmove(&game.field[1][0],
				&game.field[0][0],
				sizeof(CELL) * FIELD_COLS * (FIELD_ROWS - 1));
			memset (&game.field[0][0],
				0,
				sizeof(CELL) * FIELD_COLS);
			/*}}tB[h~*/
			if(!block_realize(0)) {
				/*{{tB[h㏸(~)*/
				memmove(&game.field[0][0],
					&game.field[1][0],
					sizeof(CELL) * FIELD_COLS * (FIELD_ROWS - 1));
				memset (&game.field[FIELD_ROWS - 1][0],
					0,
					sizeof(CELL) * FIELD_COLS);
				/*}}tB[h㏸(~)*/
			} else {
				game.down_cnt = 0;
				game.goal_row++; /* YȂ!! */
				field_gen(); /* tB[hs */
			}
		}
	}

	/* Q[I[o[B */
	rows = field_test();
	return rows <= DLINE_ROWS;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp(int f_block/*0=ubN\,1=L*/)
{
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;
	int x;
	int y;
	int sprno;
	int c;
	int x1;
	int x2;

	/* wi`܂B */
	x1 = FIELD_X;
	x2 = FIELD_X + CELL_SIZE * FIELD_COLS;
	render_rectangle_fill(&render,  0, 0,          x1, DISP_Y, 10);	/* TODO: */
	render_rectangle_fill(&render, x2, 0, DISP_X - x2, DISP_Y, 10);	/* TODO: */

	/* tB[hẼCƁAtB[hhԂ܂B */
	render_rectangle_fill(&render, x1, 0, 1, DISP_Y, 0);
	render_rectangle_fill(&render, x2, 0, 1, DISP_Y, 0);
	x1++;
	x2--;
	render_rectangle_fill(&render, x1, 0, x2 - x1 + 1, DISP_Y, 15);

	/* ubN`܂B */
	for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				continue;
			}

			/* ŃubŃANA߂ɔ\Ƃ܂B */
			if((cell1->stat == CELL_STAT_ERASE) &&
			   (game.erase_cnt >= HIDE_DELAY)) {
				continue;
			}

			/* ʏ̃ubN */
			if(row > game.goal_row) {
				switch(cell1->type) {
				case CELL_TYPE_STAGE:
					sprno = SPR_BLOCKS00;
					break;
				case CELL_TYPE_BLOCK:
					sprno = SPR_BLOCKB00;
					break;
				default:
					DIE();
				}

				if(col < FIELD_COLS - 1) {
					cell2 = &game.field[row][col + 1];
					if((cell1->type == cell2->type) &&
					   (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					   (cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE)) {
						sprno += JOIN_RI;
					}
				}
				if(col > 0) {
					cell2 = &game.field[row][col - 1];
					if((cell1->type == cell2->type) &&
					   (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					   (cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE)) {
						sprno += JOIN_LF;
					}
				}
				if(row < FIELD_ROWS - 1) {
					cell2 = &game.field[row + 1][col];
					if((cell1->type == cell2->type) &&
					   (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					  ((cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE) ||
					   (cell1->stat == CELL_STAT_RAISE && cell2->stat == CELL_STAT_RAISE))) {
						sprno += JOIN_DN;
					}
				}
				if(row > game.goal_row + 1) { /* S[ubNɂ͐ڒ܂ */
					cell2 = &game.field[row - 1][col];
					if((cell1->type == cell2->type) &&
					   (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					  ((cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE) ||
					   (cell1->stat == CELL_STAT_RAISE && cell2->stat == CELL_STAT_RAISE))) {
						sprno += JOIN_UP;
					}
				}

			/* S[ubN */
			} else {
				sprno = SPR_BLOCKG00 + ((now / 2/**/ & 3) << 4);

				/* ͎ނĂĂڒ܂Bc͐ڒ܂B */
				if(col < FIELD_COLS - 1) {
					cell2 = &game.field[row][col + 1];
					if(cell2->type &&
					  (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					  (cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE)) {
						sprno += JOIN_RI;
					}
				}
				if(col > 0) {
					cell2 = &game.field[row][col - 1];
					if(cell2->type &&
					  (cell2->stat != CELL_STAT_ERASE || game.erase_cnt < HIDE_DELAY) &&
					  (cell1->stat != CELL_STAT_RAISE && cell2->stat != CELL_STAT_RAISE)) {
						sprno += JOIN_LF;
					}
				}
			}

			x = FIELD_X + CELL_SIZE * col;
			y = FIELD_Y + CELL_SIZE * row;
			sprite_draw(x, y, sprno, DRW_NOMAL);
		}
	}

	/* ubN`܂B */
	if(f_block) {
		block_disp();
	}

	/* Obh`܂B */
	for(row = OUTER_ROWS + 1; row < FIELD_ROWS + 1; row++) {
		for(col = 1; col < FIELD_COLS; col++) {
			x = FIELD_X + CELL_SIZE * col;
			y = FIELD_Y + CELL_SIZE * row;
			c = surface_point(&surface, x, y);
			c -= 5;
			if(c < 0) {
				c = 0;
			}
			render_point(&render, x, y, c);
		}
	}

	/* S[ẘ`܂B */
	/* TODO: */

	/* fbhC`܂B */
	x1 = FIELD_X + 1;
	x2 = FIELD_X + CELL_SIZE * FIELD_COLS;
	y  = FIELD_Y + CELL_SIZE * DLINE_ROWS;
	render_line(&render, x1, y, x2, y, 10);

	/* jЃGtFNg`܂B */
	debris_disp();

	/* OGtFNgAGtFNg`܂B */
	effect_disp();
}

/****************************************************************************
 *	block_disp
 ****************************************************************************/

/* field_disp()Ăяo܂B
 * ڌĂяoȂłB
 */
void
block_disp()
{
	int col;
	int row;
	int block;
	int x;
	int y;
	int sprno;

	/* LуubN̒ʏubNɏdȂ邽߁A`܂B */
	for(row = BLOCK_ROWS - 1; row >= 0; row--) {
		for(col = 0; col < BLOCK_COLS; col++) {
			block = game.block[row][col];
			if(!block) {
				continue;
			}

			if(block < CELL_SIZE) {	/* LуubN */
				sprno = SPR_BLOCKX00 + ((block - 1) << 4);
			} else {		/* ʏubN */
				sprno = SPR_BLOCKB00;
			}

			if(col < BLOCK_COLS - 1) {
				if(game.block[row][col + 1]) {
					sprno += JOIN_RI;
				}
			}
			if(col > 0) {
				if(game.block[row][col - 1]) {
					sprno += JOIN_LF;
				}
			}
			if(row < BLOCK_ROWS - 1) {
				if(game.block[row + 1][col]) {
					sprno += JOIN_DN;
				}
			}
			if(row > 0) {
				if(game.block[row - 1][col]) {
					sprno += JOIN_UP;
				}
			}

			x = FIELD_X + CELL_SIZE * (game.block_col + col);
			y = FIELD_Y + CELL_SIZE * (game.block_row + row) + fist(game.block_pos);
			sprite_draw(x, y, sprno, DRW_NOMAL);
		}
	}
}

/****************************************************************************
 *	block_action
 ****************************************************************************/

int
block_action(int f_glow/*0=Lѕs,1=Lщ*/, int f_up/*0=㏸s,1=㏸*/)
{
	int i;
	int trg;
	int col;
	int row;
	int block;

	/* Eړ */
	if(joy & TRG_LF) {
		game.block_col--;
		if(!block_realize(0)) {
			game.block_col++;
		}
	}
	if(joy & TRG_RI) {
		game.block_col++;
		if(!block_realize(0)) {
			game.block_col--;
		}
	}

	/* L */
	if(f_glow) {
		for(i = 0; i < BLOCK_COLS; i++) {
			static const short tbl[BLOCK_COLS][2/*col,trg*/] = {
				{ 0, TRG_B     }, /*  */
				{ 2, TRG_A     }, /* E */
				{ 1, TRG_START }, /*  */
			};
			col = tbl[i][0];
			trg = tbl[i][1];
			for(row = 0; row < BLOCK_ROWS; row++) {
				block = game.block[row][col];
				if(block) {
					break;
				}
			}
			if(block) {
				if(block < CELL_SIZE) {
					game.block[row][col] = block + 1;
				}
				if(joy & trg) {
					if(row > 0) {
						game.block[row - 1][col] = 1;
						if(!block_realize(0)) {
							game.block[row - 1][col] = 0;
						} else {
							game.block[row][col] = CELL_SIZE; /* [VLZ */
						}
					}
				}
			} else {
				if(joy & trg) {
					if(i < 2/*orE*/) {
						joy |= tbl[2/**/][1]; /* Eւ̃gḰAɐUւ */
					}
				}
			}
		}
	}

	/* ㏸ */
	if(f_up) {
		if(joy & PAD_UP) {
			game.block_pos = fild(0);
			game.block_land = LAND_DELAY; /* ڒnڒ */
		} else {
			game.block_pos = fsub(game.block_pos, BLOCK_SPD);
		}
		while(ficom(game.block_pos, <=, 0)) {
			game.block_row--;
			if(!block_realize(0)) {
				game.block_row++;
				game.block_pos = fild(0);
				if(game.block_land++ >= LAND_DELAY) {
					block_realize(1);
					return 1; /* 슮 */
				} else {
					return 0; /* p */
				}
			} else {
				game.block_pos = fiadd(game.block_pos, CELL_SIZE);
				game.block_land = 0;
			}
		}
	}

	return 0; /* p */
}

/****************************************************************************
 *	block_realize
 ****************************************************************************/

int
block_realize(int f_realize/*0=eXg,1=̉*/)
{
	int col1;
	int row1;
	int col2;
	int row2;
	CELL* cell;

	for(row1 = 0; row1 < BLOCK_ROWS; row1++) {
		for(col1 = 0; col1 < BLOCK_COLS; col1++) {
			if(!game.block[row1][col1]) {
				continue;
			}

			/* ړubNʊOɂ͂ݏoĂȂ? */
			col2 = col1 + game.block_col;
			row2 = row1 + game.block_row;
			if(col2 <          0 || col2 > FIELD_COLS - 1 ||
			   row2 < OUTER_ROWS || row2 > FIELD_ROWS - 1 ||
			   row2 < game.goal_row/*YȂ!!*/) {
				if(f_realize) {
					DIE();
				} else {
					return 0; /* ̉s */
				}
			}

			/* tB[h̃ubNɏdȂĂȂ?
			 * - AfbhĆAdȂĂẲ\Ƃ܂B
			 *   ÖړubNfbhCŎ̉AŐisɁA
			 *   ̈ړubN̍EړWȂ߂̓łB
			 */
			cell = &game.field[row2][col2];
			if(cell->type && row2 < DLINE_ROWS) {
				if(f_realize) {
					DIE();
				} else {
					return 0; /* ̉s */
				}
			}

			if(f_realize) {
				memset(cell, 0, sizeof(CELL));
				cell->type = CELL_TYPE_BLOCK;
			}
		}
	}

	return 1; /* ̉\ */
}

/****************************************************************************
 *	erase_init
 ****************************************************************************/

int
erase_init()
{
	int active;
	//
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;
	//
	int min_row = FIELD_ROWS;
	int max_row = 0;

	/* ubN1CԂȂ񂾍sT܂B */
	active = 0;
	for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				break;
			}
		}
		if(col == FIELD_COLS) {
			/* A\AGtFNgʒu߂A[E[sXV܂B */
			if(row < min_row) {
				min_row = row;
			}
			if(row > max_row) {
				max_row = row;
			}
			/* S[ubNłAS[tOZbg܂B */
			if(row == game.goal_row) {
				game.goal = 1;
			/* Zł}[N܂BS[ubN͏ł܂B */
			} else {
				for(col = 0; col < FIELD_COLS; col++) {
					cell1 = &game.field[row][col];
					cell1->stat = CELL_STAT_ERASE;
				}
			}
			active = 1;
		}
	}
	if(!active) {
		game.chain = 0;	/* AI */
		return 0;       /* Ŗ */
	}

	/* ŐisJE^܂B */
	game.erase_cnt = 0;

	/* A𑝂₵A\𐶐܂B */
	game.chain++;
	if(game.chain >= 2) { /* 1A͕\A2Aȏ͕\L */
		chain_gen(min_row, max_row, game.chain);
	}

	/* łubNɗאڂAŃCɂubNo܂B
	 * - AS[ubNŎ́AS[ubNȊÕGtFNg╂s킸A
	 *   S[GtFNĝ݂Ƃ邽߁AubNo܂B
	 */
	if(!game.goal) {
		do {
			active = 0;
			for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
				for(col = 0; col < FIELD_COLS; col++) {
					cell1 = &game.field[row][col];
					if(!cell1->type ||
					    cell1->stat) {
						continue;
					}
					if(col < FIELD_COLS - 1) {
						cell2 = &game.field[row][col + 1];
						if((cell1->type == cell2->type) &&
						   (cell2->stat == CELL_STAT_RAISE)) {
							cell1->stat = CELL_STAT_RAISE;
							active = 1;
						}
					}
					if(col > 0) {
						cell2 = &game.field[row][col - 1];
						if((cell1->type == cell2->type) &&
						   (cell2->stat == CELL_STAT_RAISE)) {
							cell1->stat = CELL_STAT_RAISE;
							active = 1;
						}
					}
					if(row < FIELD_ROWS - 1) {
						cell2 = &game.field[row + 1][col];
						if((cell1->type == cell2->type) &&
						   (cell2->stat == CELL_STAT_RAISE)) {
							cell1->stat = CELL_STAT_RAISE;
							active = 1;
						}
					}
					if(row > OUTER_ROWS) {
						cell2 = &game.field[row - 1][col];
						if((cell1->type == cell2->type) &&
						   (cell2->stat == CELL_STAT_RAISE ||
						    cell2->stat == CELL_STAT_ERASE)) {
							cell1->stat = CELL_STAT_RAISE;
							active = 1;
						}
					}
				}
			}
		} while(active);

		/* jЃGtFNg𐶐܂B */
		debris_gen(min_row, max_row, 32/**/);

		/* OGtFNg𐶐܂B */
		ring_gen(min_row, max_row,
			 game.chain < 2 ? fild(0) /* 1A͐A2Aȏ͌X */
					: FRND_RANGE(seed, fmul(PI, fld(-0.25)),
							   fmul(PI, fld( 0.25))));

		/* GtFNg𐶐܂B */
		for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
			for(col = 0; col < FIELD_COLS; col++) {
				cell1 = &game.field[row][col];
				if(!cell1->type) {
					continue;
				}
				if(cell1->stat == CELL_STAT_ERASE) {
					smoke_gen(col, row, FRND_RANGE(seed, 0, SMOKE_DIST_MAX));
				}
			}
		}
	}

	return 1; /* Ŕ */
}

/****************************************************************************
 *	erase_action
 ****************************************************************************/

int
erase_action()
{
	int active = 0;
	//
	int col;
	int row;
	CELL* cell1;
	CELL* cell2;

	/* ŁEis܂B */
	for(row = OUTER_ROWS; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell1 = &game.field[row][col];
			if(!cell1->type) {
				continue;
			}

			switch(cell1->stat) {
			case CELL_STAT_ERASE:
				/* ubNŁNAxԂo߂ANA܂B */
				if(game.erase_cnt >= ERASE_DELAY) {
					memset(cell1, 0, sizeof(CELL));
				}
				active = 1;
				break;

			case CELL_STAT_RAISE:
				/* ubNŁJnxԂo߂āÃZ󂫂Ȃ΁Aサ܂B
				 * ubNŁNAxԂo߂ĂÃZ󂫂łȂ΁AŒ肵܂B
				 * (JnxԁNAx)ł邱ƂOƂĂ܂B
				 */
				if(game.erase_cnt >= RAISE_DELAY) {
					if((row > OUTER_ROWS) &&
					   (row > game.goal_row) && /* S[s˂Ȃ悤!! */
					   (!(cell2 = &game.field[row - 1][col])->type)) {
						memcpy(cell2, cell1, sizeof(CELL));
						memset(cell1,     0, sizeof(CELL));
					} else if(game.erase_cnt >= ERASE_DELAY) {
						cell1->stat = 0;
					}
				}
				active = 1;
				break;
			}
		}
	}
	game.erase_cnt++; /* YȂ!! */

	return active;
}

/****************************************************************************
 *	chain_gen
 ****************************************************************************/

void
chain_gen(int min_row, int max_row, int chain)
{
	/* TODO: */
}

/****************************************************************************
 *	debris_gen
 ****************************************************************************/

void
debris_gen(int min_row, int max_row, int num)
{
	int i_debris;
	DEBRIS* debris;
	fixed d;
	fixed spd;

	for(i_debris = 0; i_debris < DEBRIS_NUM; i_debris++) {
		debris = &game.debris[i_debris];
		if(!debris->r) {
			memset(debris, 0, sizeof(DEBRIS));
			debris->r = FRND_RANGE(seed, DEBRIS_R_INIT_MIN, DEBRIS_R_INIT_MAX);
			debris->x = fild(FIELD_X + CELL_SIZE * FIELD_COLS / 2);
			debris->y = fild(FIELD_Y + CELL_SIZE * (min_row + (max_row + 1)) / 2);
			d = FRND_RANGE(seed, 0, PI2);
			spd = FRND_RANGE(seed, DEBRIS_SPD_MIN, DEBRIS_SPD_MAX);
			debris->vx = fmul(fcos(d), spd);
			debris->vy = fmul(fsin(d), spd);
			if(!--num) {
				break; /* ܂ */
			}
		}
	}
}

/****************************************************************************
 *	debris_disp
 ****************************************************************************/

/* field_disp()Ăяo܂B
 * ڌĂяoȂłB
 */
void
debris_disp()
{
	int i_debris;
	DEBRIS* debris;

	for(i_debris = 0; i_debris < DEBRIS_NUM; i_debris++) {
		debris = &game.debris[i_debris];
		if(!debris->r) {
			continue;
		}

		render_ellipse_fill(&render,
			fist(fsub(debris->x, debris->r)),
			fist(fsub(debris->y, debris->r)),
			fist(fimul(debris->r, 2)),
			fist(fimul(debris->r, 2)),
			0);

		debris->r = fmul(debris->r, DEBRIS_R_RATE);
		debris->x = fadd(debris->x, debris->vx);
		debris->y = fadd(debris->y, debris->vy);
		if(ficom(debris->r, <, 1) ||
		   ficom(debris->x, <, 0) || ficom(debris->x, >, DISP_X - 1) ||
		   ficom(debris->y, <, 0) || ficom(debris->y, >, DISP_Y - 1)) {
			debris->r = fild(0);
		}
	}
}

/****************************************************************************
 *	ring_gen
 ****************************************************************************/

void
ring_gen(int min_row, int max_row, fixed d)
{
	int i_ring;
	RING* ring;

	for(i_ring = 0; i_ring < RING_NUM; i_ring++) {
		ring = &game.ring[i_ring];
		if(!ring->a) {
			memset(ring, 0, sizeof(RING));
			ring->a = RING_A_INIT;
			ring->d = d;
			ring->y = fild(FIELD_Y + CELL_SIZE * (min_row + (max_row + 1)) / 2);
			break; /* ܂ */
		}
	}
}

/****************************************************************************
 *	ring_disp
 ****************************************************************************/

/* effect_disp()Ăяo܂B
 * ڌĂяoȂłB
 */
void
ring_disp()
{
	int i_ring;
	RING* ring;
	fixed r_inner;
	fixed r_outer;
	VERTEX vtx[4];
	int i;
	fixed d;
	vector v;
	matrix m;

	effect_render[EFFECT_RING].context->texture = NULL;

	for(i_ring = 0; i_ring < RING_NUM; i_ring++) {
		ring = &game.ring[i_ring];
		if(!ring->a) {
			continue;
		}

		m = MATRIX_I;
		m = mxlate(m,
			fild(FIELD_X + CELL_SIZE * FIELD_COLS / 2),
			ring->y,
			fld(0.0));
		m = mrotz(m,
			ring->d);
		m = mscale(m,
			fld(1.0),
			fld(0.2),
			fld(0.0));

		r_outer = fadd(ring->r, ring->a);
		r_inner = ring->r;

		for(i = 0; i <= RING_DIV; i++) {
			vtx[0] = vtx[3];
			//
			vtx[1] = vtx[2];
			//
			d = fidiv(fimul(PI2, i), RING_DIV);
			v.x = fmul(fcos(d), r_outer);
			v.y = fmul(fsin(d), r_outer);
			v = vxform(m, v);
			vtx[2].x = fist(v.x);
			vtx[2].y = fist(v.y);
			//
			d = fidiv(fimul(PI2, i), RING_DIV);
			v.x = fmul(fcos(d), r_inner);
			v.y = fmul(fsin(d), r_inner);
			v = vxform(m, v);
			vtx[3].x = fist(v.x);
			vtx[3].y = fist(v.y);
			//
			if(i) {
				render_polygon(&effect_render[EFFECT_RING],
					vtx,
					4,
					15/**/);
			}
		}

		ring->r = fadd(ring->r, ring->a);
		ring->a = fsub(ring->a, RING_A_DECL);
		if(ficom(ring->a, <, 0)) {
			ring->a = fild(0);
		}
	}
}

/****************************************************************************
 *	rring_disp
 ****************************************************************************/

/* effect_disp()Ăяo܂B
 * ڌĂяoȂłB
 */
void
rring_disp()
{
	fixed r_inner;
	fixed r_outer;
	VERTEX vtx[4];
	int i;
	fixed d;
	vector v;
	matrix m;

	effect_render[EFFECT_RING].context->texture = NULL;

	if(game.rring_cnt) {
		m = MATRIX_I;
		m = mxlate(m,
			fild(FIELD_X + CELL_SIZE * FIELD_COLS / 2),
			fild(FIELD_Y + CELL_SIZE * game.goal_row + CELL_HALF),
			fld(0.0));
		m = mscale(m,
			fld(1.0),
			fld(0.2),
			fld(0.0));

		r_outer = fidiv(fimul(RRING_R_OUTER, game.rring_cnt), RRING_TIME);
		r_inner = fidiv(fimul(RRING_R_INNER, game.rring_cnt), RRING_TIME);

		for(i = 0; i <= RING_DIV; i++) {
			vtx[0] = vtx[3];
			//
			vtx[1] = vtx[2];
			//
			d = fidiv(fimul(PI2, i), RING_DIV);
			v.x = fmul(fcos(d), r_outer);
			v.y = fmul(fsin(d), r_outer);
			v = vxform(m, v);
			vtx[2].x = fist(v.x);
			vtx[2].y = fist(v.y);
			//
			d = fidiv(fimul(PI2, i), RING_DIV);
			v.x = fmul(fcos(d), r_inner);
			v.y = fmul(fsin(d), r_inner);
			v = vxform(m, v);
			vtx[3].x = fist(v.x);
			vtx[3].y = fist(v.y);
			//
			if(i) {
				render_polygon(&effect_render[EFFECT_RING],
					vtx,
					4,
					15 - (15 * game.rring_cnt / RRING_TIME));
			}
		}

		game.rring_cnt--;
	}
}

/****************************************************************************
 *	smoke_gen
 ****************************************************************************/

void
smoke_gen(int col, int row, fixed dist)
{
	int i_smoke;
	SMOKE* smoke;
	fixed d;

	for(i_smoke = 0; i_smoke < SMOKE_NUM; i_smoke++) {
		smoke = &game.smoke[i_smoke];
		if(!smoke->r) {
			memset(smoke, 0, sizeof(SMOKE));
			smoke->r = FRND_RANGE(seed, SMOKE_R_INIT_MIN, SMOKE_R_INIT_MAX);
			d = FRND_RANGE(seed, 0, PI2);
			smoke->x = fiadd(fmul(fcos(d), dist), FIELD_X + CELL_SIZE * col + CELL_HALF);
			smoke->y = fiadd(fmul(fsin(d), dist), FIELD_Y + CELL_SIZE * row + CELL_HALF);
			break; /* ܂ */
		}
	}
}

/****************************************************************************
 *	smoke_disp
 ****************************************************************************/

/* effect_disp()Ăяo܂B
 * ڌĂяoȂłB
 */
void
smoke_disp()
{
	int i_smoke;
	SMOKE* smoke;
	fixed d;
	fixed r;

	for(i_smoke = 0; i_smoke < SMOKE_NUM; i_smoke++) {
		smoke = &game.smoke[i_smoke];
		if(!smoke->r) {
			continue;
		}

		d = fidiv(fimul(PI_2, smoke->cnt), SMOKE_CNT_MAX);
		r = fmul(smoke->r, fsin(d));

		render_ellipse_fill(&effect_render[EFFECT_SMOKE],
			fist(fsub(smoke->x, r)),
			fist(fsub(smoke->y, r)),
			fist(fimul(r, 2)),
			fist(fimul(r, 2)),
			9/**/);

		if(smoke->cnt < SMOKE_CNT_MAX) {
			smoke->cnt++;
		} else {
			smoke->r = fmul(smoke->r, SMOKE_R_RATE);
			if(ficom(smoke->r, <, 1)) {
				smoke->r = fild(0);
			}
		}
	}
}

